﻿#pragma warning disable 1591
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.3082
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;



[System.Data.Linq.Mapping.DatabaseAttribute(Name="EpamSharesIndex")]
public partial class SearchIndexDataContext : System.Data.Linq.DataContext
{
	
	private static System.Data.Linq.Mapping.MappingSource mappingSource = new AttributeMappingSource();
	
  #region Extensibility Method Definitions
  partial void OnCreated();
  partial void InsertFile(File instance);
  partial void UpdateFile(File instance);
  partial void DeleteFile(File instance);
  partial void InsertFolder(Folder instance);
  partial void UpdateFolder(Folder instance);
  partial void DeleteFolder(Folder instance);
  #endregion
	
	public SearchIndexDataContext() : 
			base(global::System.Configuration.ConfigurationManager.ConnectionStrings["TestEpamSharesIndexConnectionString"].ConnectionString, mappingSource)
	{
		OnCreated();
	}
	
	public SearchIndexDataContext(string connection) : 
			base(connection, mappingSource)
	{
		OnCreated();
	}
	
	public SearchIndexDataContext(System.Data.IDbConnection connection) : 
			base(connection, mappingSource)
	{
		OnCreated();
	}
	
	public SearchIndexDataContext(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
			base(connection, mappingSource)
	{
		OnCreated();
	}
	
	public SearchIndexDataContext(System.Data.IDbConnection connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
			base(connection, mappingSource)
	{
		OnCreated();
	}
	
	public System.Data.Linq.Table<File> Files
	{
		get
		{
			return this.GetTable<File>();
		}
	}
	
	public System.Data.Linq.Table<Folder> Folders
	{
		get
		{
			return this.GetTable<Folder>();
		}
	}
	
	public System.Data.Linq.Table<FileInfo> FileInfos
	{
		get
		{
			return this.GetTable<FileInfo>();
		}
	}
	
	[Function(Name="dbo.Search")]
	public ISingleResult<FileInfo> Search([Parameter(DbType="NVarChar(1000)")] string phrase, [Parameter(DbType="NVarChar(100)")] string type)
	{
		IExecuteResult result = this.ExecuteMethodCall(this, ((MethodInfo)(MethodInfo.GetCurrentMethod())), phrase, type);
		return ((ISingleResult<FileInfo>)(result.ReturnValue));
	}
}

[Table(Name="dbo.[File]")]
public partial class File : INotifyPropertyChanging, INotifyPropertyChanged
{
	
	private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
	
	private int _file_id;
	
	private int _parent_folder_id;
	
	private string _name;
	
	private string _type;
	
	private long _size;
	
	private System.Data.Linq.Binary _indexed_on;
	
	private EntityRef<Folder> _Folder;
	
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void Onfile_idChanging(int value);
    partial void Onfile_idChanged();
    partial void Onparent_folder_idChanging(int value);
    partial void Onparent_folder_idChanged();
    partial void OnnameChanging(string value);
    partial void OnnameChanged();
    partial void OntypeChanging(string value);
    partial void OntypeChanged();
    partial void OnsizeChanging(long value);
    partial void OnsizeChanged();
    partial void Onindexed_onChanging(System.Data.Linq.Binary value);
    partial void Onindexed_onChanged();
    #endregion
	
	public File()
	{
		this._Folder = default(EntityRef<Folder>);
		OnCreated();
	}
	
	[Column(Storage="_file_id", DbType="Int NOT NULL", IsPrimaryKey=true, UpdateCheck=UpdateCheck.Never)]
	public int file_id
	{
		get
		{
			return this._file_id;
		}
		set
		{
			if ((this._file_id != value))
			{
				this.Onfile_idChanging(value);
				this.SendPropertyChanging();
				this._file_id = value;
				this.SendPropertyChanged("file_id");
				this.Onfile_idChanged();
			}
		}
	}
	
	[Column(Storage="_parent_folder_id", DbType="Int NOT NULL", UpdateCheck=UpdateCheck.Never)]
	public int parent_folder_id
	{
		get
		{
			return this._parent_folder_id;
		}
		set
		{
			if ((this._parent_folder_id != value))
			{
				if (this._Folder.HasLoadedOrAssignedValue)
				{
					throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
				}
				this.Onparent_folder_idChanging(value);
				this.SendPropertyChanging();
				this._parent_folder_id = value;
				this.SendPropertyChanged("parent_folder_id");
				this.Onparent_folder_idChanged();
			}
		}
	}
	
	[Column(Storage="_name", DbType="NVarChar(255)", UpdateCheck=UpdateCheck.Never)]
	public string name
	{
		get
		{
			return this._name;
		}
		set
		{
			if ((this._name != value))
			{
				this.OnnameChanging(value);
				this.SendPropertyChanging();
				this._name = value;
				this.SendPropertyChanged("name");
				this.OnnameChanged();
			}
		}
	}
	
	[Column(Storage="_type", DbType="NVarChar(50)", UpdateCheck=UpdateCheck.Never)]
	public string type
	{
		get
		{
			return this._type;
		}
		set
		{
			if ((this._type != value))
			{
				this.OntypeChanging(value);
				this.SendPropertyChanging();
				this._type = value;
				this.SendPropertyChanged("type");
				this.OntypeChanged();
			}
		}
	}
	
	[Column(Storage="_size", DbType="BigInt NOT NULL", UpdateCheck=UpdateCheck.Never)]
	public long size
	{
		get
		{
			return this._size;
		}
		set
		{
			if ((this._size != value))
			{
				this.OnsizeChanging(value);
				this.SendPropertyChanging();
				this._size = value;
				this.SendPropertyChanged("size");
				this.OnsizeChanged();
			}
		}
	}
	
	[Column(Storage="_indexed_on", AutoSync=AutoSync.Always, DbType="rowversion", IsDbGenerated=true, IsVersion=true, UpdateCheck=UpdateCheck.Never)]
	public System.Data.Linq.Binary indexed_on
	{
		get
		{
			return this._indexed_on;
		}
		set
		{
			if ((this._indexed_on != value))
			{
				this.Onindexed_onChanging(value);
				this.SendPropertyChanging();
				this._indexed_on = value;
				this.SendPropertyChanged("indexed_on");
				this.Onindexed_onChanged();
			}
		}
	}
	
	[Association(Name="Folder_File", Storage="_Folder", ThisKey="parent_folder_id", OtherKey="folder_id", IsForeignKey=true)]
	public Folder Folder
	{
		get
		{
			return this._Folder.Entity;
		}
		set
		{
			Folder previousValue = this._Folder.Entity;
			if (((previousValue != value) 
						|| (this._Folder.HasLoadedOrAssignedValue == false)))
			{
				this.SendPropertyChanging();
				if ((previousValue != null))
				{
					this._Folder.Entity = null;
					previousValue.Files.Remove(this);
				}
				this._Folder.Entity = value;
				if ((value != null))
				{
					value.Files.Add(this);
					this._parent_folder_id = value.folder_id;
				}
				else
				{
					this._parent_folder_id = default(int);
				}
				this.SendPropertyChanged("Folder");
			}
		}
	}
	
	public event PropertyChangingEventHandler PropertyChanging;
	
	public event PropertyChangedEventHandler PropertyChanged;
	
	protected virtual void SendPropertyChanging()
	{
		if ((this.PropertyChanging != null))
		{
			this.PropertyChanging(this, emptyChangingEventArgs);
		}
	}
	
	protected virtual void SendPropertyChanged(String propertyName)
	{
		if ((this.PropertyChanged != null))
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}
}

[Table(Name="dbo.Folder")]
public partial class Folder : INotifyPropertyChanging, INotifyPropertyChanged
{
	
	private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
	
	private int _folder_id;
	
	private int _parent_id;
	
	private string _path;
	
	private System.Data.Linq.Binary _indexed_on;
	
	private EntitySet<File> _Files;
	
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void Onfolder_idChanging(int value);
    partial void Onfolder_idChanged();
    partial void Onparent_idChanging(int value);
    partial void Onparent_idChanged();
    partial void OnpathChanging(string value);
    partial void OnpathChanged();
    partial void Onindexed_onChanging(System.Data.Linq.Binary value);
    partial void Onindexed_onChanged();
    #endregion
	
	public Folder()
	{
		this._Files = new EntitySet<File>(new Action<File>(this.attach_Files), new Action<File>(this.detach_Files));
		OnCreated();
	}
	
	[Column(Storage="_folder_id", DbType="Int NOT NULL", IsPrimaryKey=true, UpdateCheck=UpdateCheck.Never)]
	public int folder_id
	{
		get
		{
			return this._folder_id;
		}
		set
		{
			if ((this._folder_id != value))
			{
				this.Onfolder_idChanging(value);
				this.SendPropertyChanging();
				this._folder_id = value;
				this.SendPropertyChanged("folder_id");
				this.Onfolder_idChanged();
			}
		}
	}
	
	[Column(Storage="_parent_id", DbType="Int NOT NULL", UpdateCheck=UpdateCheck.Never)]
	public int parent_id
	{
		get
		{
			return this._parent_id;
		}
		set
		{
			if ((this._parent_id != value))
			{
				this.Onparent_idChanging(value);
				this.SendPropertyChanging();
				this._parent_id = value;
				this.SendPropertyChanged("parent_id");
				this.Onparent_idChanged();
			}
		}
	}
	
	[Column(Storage="_path", DbType="NVarChar(4000) NOT NULL", CanBeNull=false, UpdateCheck=UpdateCheck.Never)]
	public string path
	{
		get
		{
			return this._path;
		}
		set
		{
			if ((this._path != value))
			{
				this.OnpathChanging(value);
				this.SendPropertyChanging();
				this._path = value;
				this.SendPropertyChanged("path");
				this.OnpathChanged();
			}
		}
	}
	
	[Column(Storage="_indexed_on", AutoSync=AutoSync.Always, DbType="rowversion", IsDbGenerated=true, IsVersion=true, UpdateCheck=UpdateCheck.Never)]
	public System.Data.Linq.Binary indexed_on
	{
		get
		{
			return this._indexed_on;
		}
		set
		{
			if ((this._indexed_on != value))
			{
				this.Onindexed_onChanging(value);
				this.SendPropertyChanging();
				this._indexed_on = value;
				this.SendPropertyChanged("indexed_on");
				this.Onindexed_onChanged();
			}
		}
	}
	
	[Association(Name="Folder_File", Storage="_Files", ThisKey="folder_id", OtherKey="parent_folder_id")]
	public EntitySet<File> Files
	{
		get
		{
			return this._Files;
		}
		set
		{
			this._Files.Assign(value);
		}
	}
	
	public event PropertyChangingEventHandler PropertyChanging;
	
	public event PropertyChangedEventHandler PropertyChanged;
	
	protected virtual void SendPropertyChanging()
	{
		if ((this.PropertyChanging != null))
		{
			this.PropertyChanging(this, emptyChangingEventArgs);
		}
	}
	
	protected virtual void SendPropertyChanged(String propertyName)
	{
		if ((this.PropertyChanged != null))
		{
			this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}
	
	private void attach_Files(File entity)
	{
		this.SendPropertyChanging();
		entity.Folder = this;
	}
	
	private void detach_Files(File entity)
	{
		this.SendPropertyChanging();
		entity.Folder = null;
	}
}

[Table(Name="dbo.vFileInfo")]
public partial class FileInfo
{
	
	private string _name;
	
	private string _path;
	
	private string _FullName;
	
	private long _size;
	
	private string _type;
	
	public FileInfo()
	{
	}
	
	[Column(Storage="_name", DbType="NVarChar(255)")]
	public string name
	{
		get
		{
			return this._name;
		}
		set
		{
			if ((this._name != value))
			{
				this._name = value;
			}
		}
	}
	
	[Column(Storage="_path", DbType="NVarChar(4000) NOT NULL", CanBeNull=false)]
	public string path
	{
		get
		{
			return this._path;
		}
		set
		{
			if ((this._path != value))
			{
				this._path = value;
			}
		}
	}
	
	[Column(Storage="_FullName", DbType="NVarChar(4000)")]
	public string FullName
	{
		get
		{
			return this._FullName;
		}
		set
		{
			if ((this._FullName != value))
			{
				this._FullName = value;
			}
		}
	}
	
	[Column(Storage="_size", DbType="BigInt NOT NULL")]
	public long size
	{
		get
		{
			return this._size;
		}
		set
		{
			if ((this._size != value))
			{
				this._size = value;
			}
		}
	}
	
	[Column(Storage="_type", DbType="NVarChar(50)")]
	public string type
	{
		get
		{
			return this._type;
		}
		set
		{
			if ((this._type != value))
			{
				this._type = value;
			}
		}
	}
}
#pragma warning restore 1591
